/*
 *  * Copyright (c) 2004 Xilinx, Inc.  All rights reserved.
 *
 * Xilinx, Inc.
 * XILINX IS PROVIDING THIS DESIGN, CODE, OR INFORMATION "AS IS" AS A 
 * COURTESY TO YOU.  BY PROVIDING THIS DESIGN, CODE, OR INFORMATION AS
 * ONE POSSIBLE   IMPLEMENTATION OF THIS FEATURE, APPLICATION OR 
 * STANDARD, XILINX IS MAKING NO REPRESENTATION THAT THIS IMPLEMENTATION 
 * IS FREE FROM ANY CLAIMS OF INFRINGEMENT, AND YOU ARE RESPONSIBLE 
 * FOR OBTAINING ANY RIGHTS YOU MAY REQUIRE FOR YOUR IMPLEMENTATION
 * XILINX EXPRESSLY DISCLAIMS ANY WARRANTY WHATSOEVER WITH RESPECT TO 
 * THE ADEQUACY OF THE IMPLEMENTATION, INCLUDING BUT NOT LIMITED TO 
 * ANY WARRANTIES OR REPRESENTATIONS THAT THIS IMPLEMENTATION IS FREE 
 * FROM CLAIMS OF INFRINGEMENT, IMPLIED WARRANTIES OF MERCHANTABILITY 
 * AND FITNESS FOR A PARTICULAR PURPOSE.
 */

/*
 * Xilinx EDK 8.1.02 EDK_I.20.4
 *
 * This file is a sample test application
 *
 * This application is intended to test and/or illustrate some 
 * functionality of your system.  The contents of this file may
 * vary depending on the IP in your system and may use existing
 * IP driver functions.  These drivers will be generated in your
 * XPS project when you run the "Generate Libraries" menu item
 * in XPS.
 *
 * Your XPS project directory is at:
 *    C:\work\tutorials\Memec\Sp3_MB\ISE_EDK_81\Memec_3SMB_MicroBlaze_Base\3SMB_BSB_EDK81\
 */


// Located in: microblaze_0/include/xparameters.h
#include "xparameters.h"

#include "mb_interface.h"

#include "stdio.h"

#include "xutil.h"

#define DDRBYTES     (XPAR_DDR_SDRAM_16MX16_MEM0_HIGHADDR - XPAR_DDR_SDRAM_16MX16_MEM0_BASEADDR + 1)
#define DDRHWORDS    (DDRBYTES / 2)
#define DDRWORDS     (DDRBYTES / 4)

//====================================================

int main (void) {


   /*
    * Enable and initialize cache
    */
   microblaze_init_icache_range(0, 8192);
   microblaze_enable_icache();

   microblaze_init_dcache_range(0, 8192);
   microblaze_enable_dcache();

   print("-- Entering main() --\r\n");

   /* 
    * MemoryTest routine will not be run for the memory at 
    * 0x00000000 (dlmb_cntlr)
    * because it is being used to hold a part of this application program
    */


   /* 
    * MemoryTest routine will not be run for the memory at 
    * 0x21000000 (FLASH_2Mx16)
    * because it is a read-only memory
    */


   /* Testing DDR Memory (DDR_SDRAM_16Mx16)*/
   {
      XStatus status;

      print("Starting MemoryTest for DDR_SDRAM_16Mx16:\r\n");
      print("  Running 32-bit test...");
      // status = XUtil_MemoryTest32((Xuint32*)XPAR_DDR_SDRAM_16MX16_MEM0_BASEADDR, 1024, 0xAAAA5555, XUT_ALLMEMTESTS);
      status = XUtil_MemoryTest32((Xuint32*)XPAR_DDR_SDRAM_16MX16_MEM0_BASEADDR, DDRWORDS, 0xAAAA5555, XUT_ALLMEMTESTS);
      if (status == XST_SUCCESS) {
         print("PASSED!\r\n");
      }
      else {
         print("FAILED!\r\n");
      }
      print("  Running 16-bit test...");
      // status = XUtil_MemoryTest16((Xuint16*)XPAR_DDR_SDRAM_16MX16_MEM0_BASEADDR, 2048, 0xAA55, XUT_ALLMEMTESTS);
      status = XUtil_MemoryTest16((Xuint16*)XPAR_DDR_SDRAM_16MX16_MEM0_BASEADDR, DDRHWORDS, 0xAA55, XUT_ALLMEMTESTS);
      if (status == XST_SUCCESS) {
         print("PASSED!\r\n");
      }
      else {
         print("FAILED!\r\n");
      }
      print("  Running 8-bit test...");
      // status = XUtil_MemoryTest8((Xuint8*)XPAR_DDR_SDRAM_16MX16_MEM0_BASEADDR, 4096, 0xA5, XUT_ALLMEMTESTS);
      status = XUtil_MemoryTest8((Xuint8*)XPAR_DDR_SDRAM_16MX16_MEM0_BASEADDR, DDRBYTES, 0xA5, XUT_ALLMEMTESTS);
      if (status == XST_SUCCESS) {
         print("PASSED!\r\n");
      }
      else {
         print("FAILED!\r\n");
      }
   }
   /*
    * Disable cache and reinitialize it so that other
    * applications can be run with no problems
    */
   microblaze_disable_dcache();
   microblaze_init_dcache_range(0, 8192);

   microblaze_disable_icache();
   microblaze_init_icache_range(0, 8192);


   print("-- Exiting main() --\r\n");
   return 0;
}

