/*-----------------------------------------------------------------------------
//
//     MEMEC IS PROVIDING THIS DESIGN, CODE, OR INFORMATION "AS IS"
//     SOLELY FOR USE IN DEVELOPING PROGRAMS AND SOLUTIONS FOR
//     XILINX DEVICES.  BY PROVIDING THIS DESIGN, CODE, OR INFORMATION
//     AS ONE POSSIBLE IMPLEMENTATION OF THIS FEATURE, APPLICATION
//     OR STANDARD, MEMEC IS MAKING NO REPRESENTATION THAT THIS
//     IMPLEMENTATION IS FREE FROM ANY CLAIMS OF INFRINGEMENT,
//     AND YOU ARE RESPONSIBLE FOR OBTAINING ANY RIGHTS YOU MAY REQUIRE
//     FOR YOUR IMPLEMENTATION.  MEMEC EXPRESSLY DISCLAIMS ANY
//     WARRANTY WHATSOEVER WITH RESPECT TO THE ADEQUACY OF THE
//     IMPLEMENTATION, INCLUDING BUT NOT LIMITED TO ANY WARRANTIES OR
//     REPRESENTATIONS THAT THIS IMPLEMENTATION IS FREE FROM CLAIMS OF
//     INFRINGEMENT, IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS
//     FOR A PARTICULAR PURPOSE.
//     
//     (c) Copyright 2002 Memec, Inc.
//     All rights reserved.
//
//---------------------------------------------------------------------------*/

/******************************************************************************
* Function name         :  function.c
* returns               :  
* Created by            :  Nasser Poureh 
* Date Created          :  2/2/03
* Company				:  Insight Electronics
* Description           :  function driver
* Notes                 :  
******************************************************************************/
#include "xuartlite_l.h"
#include "xparameters.h"
#include "function.h"
#include "xgpio_l.h"

#define true 1


//	The following function generates a variable delay

void _wait(loop_count)
int	loop_count;
{

int	sum, data;

sum	= 0;

for (data = 0; data < loop_count; data++) {
	sum = (data << 8);
}
  return;
}



//	The following function provides a simple print routine to print
//	characters to the UART. If stdio.h is included in the main program and
//	the UART is set to be STDIN/STDOUT, then a simple printf() function could
//	also be used.
void printf_uart(char *s)
{
	while (*s)
	{
		XUartLite_SendByte(XPAR_RS232_BASEADDR,*s);
		while (XUartLite_mIsTransmitFull(XPAR_RS232_BASEADDR) == true) {
		};
		s++;
	}
	return;
}




//	The following function displays an integer in binary format.
void printf_data(int data, int start_shift, int end_shift)
{
	int i, val;

	for (i = start_shift; i < end_shift; i++) {
		val = (data << i) & 0x80000000;
		if (val == 0x80000000) {
			printf_uart("1");
		}
		else {
			printf_uart("0");
		}
	}
	printf_uart("\n\r");
}

