/*-----------------------------------------------------------------------------
//
//     MEMEC IS PROVIDING THIS DESIGN, CODE, OR INFORMATION "AS IS"
//     SOLELY FOR USE IN DEVELOPING PROGRAMS AND SOLUTIONS FOR
//     XILINX DEVICES.  BY PROVIDING THIS DESIGN, CODE, OR INFORMATION
//     AS ONE POSSIBLE IMPLEMENTATION OF THIS FEATURE, APPLICATION
//     OR STANDARD, MEMEC IS MAKING NO REPRESENTATION THAT THIS
//     IMPLEMENTATION IS FREE FROM ANY CLAIMS OF INFRINGEMENT,
//     AND YOU ARE RESPONSIBLE FOR OBTAINING ANY RIGHTS YOU MAY REQUIRE
//     FOR YOUR IMPLEMENTATION.  MEMEC EXPRESSLY DISCLAIMS ANY
//     WARRANTY WHATSOEVER WITH RESPECT TO THE ADEQUACY OF THE
//     IMPLEMENTATION, INCLUDING BUT NOT LIMITED TO ANY WARRANTIES OR
//     REPRESENTATIONS THAT THIS IMPLEMENTATION IS FREE FROM CLAIMS OF
//     INFRINGEMENT, IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS
//     FOR A PARTICULAR PURPOSE.
//     
//     (c) Copyright 2002 Memec, Inc.
//     All rights reserved.
//
//---------------------------------------------------------------------------*/

/******************************************************************************
* Function name         :  light_leds.c
* returns               :  
* Created by            :  Aubrey Arnoczy
* Date Created          :  11/16/02
* Company			    :  Insight Electronics
* Description           :  Main Program
* Revisions:
*	8/13/03  modified for boot loader example, changed to #defines from
*            xparameters.h (bhf)
******************************************************************************/

#include "xparameters.h"
#include "xgpio_l.h"

void light_leds(void)
{

 int	gpio_data;

 XGpio_mSetDataDirection(XPAR_LEDS_4BIT_BASEADDR, 1, 0x00000000);
 gpio_data = 0x00000008;


 while (1) 
 {		

	while (gpio_data != 0x00000001)
	{
		XGpio_mSetDataReg(XPAR_LEDS_4BIT_BASEADDR, 1, ~(gpio_data));
		gpio_data = gpio_data >> 1; 
		_wait(300000);
	}

	while (gpio_data != 0x00000008)
	{
		XGpio_mSetDataReg(XPAR_LEDS_4BIT_BASEADDR, 1, ~(gpio_data));
		gpio_data = gpio_data << 1; 
		_wait(900000);
	}
 }

 return;
}
