/*-----------------------------------------------------------------------------
//
//     MEMEC IS PROVIDING THIS DESIGN, CODE, OR INFORMATION "AS IS"
//     SOLELY FOR USE IN DEVELOPING PROGRAMS AND SOLUTIONS FOR
//     XILINX DEVICES.  BY PROVIDING THIS DESIGN, CODE, OR INFORMATION
//     AS ONE POSSIBLE IMPLEMENTATION OF THIS FEATURE, APPLICATION
//     OR STANDARD, MEMEC IS MAKING NO REPRESENTATION THAT THIS
//     IMPLEMENTATION IS FREE FROM ANY CLAIMS OF INFRINGEMENT,
//     AND YOU ARE RESPONSIBLE FOR OBTAINING ANY RIGHTS YOU MAY REQUIRE
//     FOR YOUR IMPLEMENTATION.  MEMEC EXPRESSLY DISCLAIMS ANY
//     WARRANTY WHATSOEVER WITH RESPECT TO THE ADEQUACY OF THE
//     IMPLEMENTATION, INCLUDING BUT NOT LIMITED TO ANY WARRANTIES OR
//     REPRESENTATIONS THAT THIS IMPLEMENTATION IS FREE FROM CLAIMS OF
//     INFRINGEMENT, IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS
//     FOR A PARTICULAR PURPOSE.
//     
//     (c) Copyright 2002 Memec, Inc.
//     All rights reserved.
//
//---------------------------------------------------------------------------*/

#include "function.h"

extern void light_leds(void);


main()
{

   /*
    * Enable and initialize cache
    */
   microblaze_init_icache_range(0, 8192);
   microblaze_enable_icache();

   microblaze_init_dcache_range(0, 8192);
   microblaze_enable_dcache();

//   The following prints a banner on the Hyper Terminal.

printf_uart("         ####################################################\n\r");
printf_uart("         #                                                  #\n\r");
printf_uart("         #                        Memec                     #\n\r");
printf_uart("         #           3SMB MicroBlaze Development Board      #\n\r");
printf_uart("         #           Running from DDR Reference Design      #\n\r");
printf_uart("         #                     Linker Script                #\n\r");
printf_uart("         ####################################################\n\r");
printf_uart("\n\r\n");

light_leds();

   /*
    * Disable cache and reinitialize it so that other
    * applications can be run with no problems
    */
   microblaze_disable_dcache();
   microblaze_init_dcache_range(0, 8192);

   microblaze_disable_icache();
   microblaze_init_icache_range(0, 8192);

}
