/*-----------------------------------------------------------------------------
//
//     MEMEC IS PROVIDING THIS DESIGN, CODE, OR INFORMATION "AS IS"
//     SOLELY FOR USE IN DEVELOPING PROGRAMS AND SOLUTIONS FOR
//     XILINX DEVICES.  BY PROVIDING THIS DESIGN, CODE, OR INFORMATION
//     AS ONE POSSIBLE IMPLEMENTATION OF THIS FEATURE, APPLICATION
//     OR STANDARD, MEMEC IS MAKING NO REPRESENTATION THAT THIS
//     IMPLEMENTATION IS FREE FROM ANY CLAIMS OF INFRINGEMENT,
//     AND YOU ARE RESPONSIBLE FOR OBTAINING ANY RIGHTS YOU MAY REQUIRE
//     FOR YOUR IMPLEMENTATION.  MEMEC EXPRESSLY DISCLAIMS ANY
//     WARRANTY WHATSOEVER WITH RESPECT TO THE ADEQUACY OF THE
//     IMPLEMENTATION, INCLUDING BUT NOT LIMITED TO ANY WARRANTIES OR
//     REPRESENTATIONS THAT THIS IMPLEMENTATION IS FREE FROM CLAIMS OF
//     INFRINGEMENT, IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS
//     FOR A PARTICULAR PURPOSE.
//     
//     (c) Copyright 2005 Memec, Inc.
//     All rights reserved.
//
//---------------------------------------------------------------------------*/

/* 
/******************************************************************************
*
*       XILINX IS PROVIDING THIS DESIGN, CODE, OR INFORMATION "AS IS"
*       AS A COURTESY TO YOU, SOLELY FOR USE IN DEVELOPING PROGRAMS AND
*       SOLUTIONS FOR XILINX DEVICES.  BY PROVIDING THIS DESIGN, CODE,
*       OR INFORMATION AS ONE POSSIBLE IMPLEMENTATION OF THIS FEATURE,
*       APPLICATION OR STANDARD, XILINX IS MAKING NO REPRESENTATION
*       THAT THIS IMPLEMENTATION IS FREE FROM ANY CLAIMS OF INFRINGEMENT,
*       AND YOU ARE RESPONSIBLE FOR OBTAINING ANY RIGHTS YOU MAY REQUIRE
*       FOR YOUR IMPLEMENTATION.  XILINX EXPRESSLY DISCLAIMS ANY
*       WARRANTY WHATSOEVER WITH RESPECT TO THE ADEQUACY OF THE
*       IMPLEMENTATION, INCLUDING BUT NOT LIMITED TO ANY WARRANTIES OR
*       REPRESENTATIONS THAT THIS IMPLEMENTATION IS FREE FROM CLAIMS OF
*       INFRINGEMENT, IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS
*       FOR A PARTICULAR PURPOSE.
*
*       (c) Copyright 2002 Xilinx Inc.
*       All rights reserved.
*
******************************************************************************/
/*****************************************************************************/

// 3/25/04 Modified by Memec for 3SMB board and Internet Explorer

/***************************** Include Files *********************************/
#include <stdio.h>
#include <string.h>
#include <net/xilnet_config.h>
#include <net/xilsock.h>
#include <mfs_config.h>
#include <web.h>
#include <xgpio_l.h>
#include <xemac_l.h>
#include <xparameters.h>

/*
 * Function prototypes and global variables
 */

#define BUFSIZE 50
char buf[BUFSIZE];
volatile unsigned char dip[8];

unsigned char *bg_tab[] = {"#63B1B1","#FFFFCC","#808040","#FFCC99","#CC6600", "#99FF99"};
unsigned char http_hdr[17] = {0x48,0x54,0x54,0x50,0x2f,0x31,0x2e,0x30,0x20,0x32,0x30,0x30,0x20,0x4f,0x4b,0x0d,0x0a};  
unsigned char file_not_found[24] = {0x48,0x54,0x54,0x50,0x2f,0x31,0x2e,0x30,0x20,0x34,0x30,0x34,0x20,0x4e,
                                    0x6f,0x74,0x20,0x46,0x6f,0x75,0x6e,0x64,0x0d,0x0a};  
unsigned int led_tab[16] = {0xf,0xe,0xd,0xc,0xb,0xa,0x9,0x8,0x7,0x6,0x5,0x4,0x3,0x2,0x1,0x0};
unsigned int display_data[16] =	{0x38, 0x30, 0x42, 0x31, 0x60, 0x08, 0x04, 0x00, 0x0f, 0x20, 0x24, 0x4c, 0x06, 0x12, 0x4f, 0x01};

unsigned char d2 = 0xf;
unsigned char led = 0xf;
int count = 0;

void do_proc_req(int);
void create_index (void);
void do_proc_conns();

/******************************************************************************
******************************************************************************/
char *ticker = {"^>v<"};
char nextTicker=0;

#include <xbasic_types.h>

void _wait(loop_count)
int	loop_count;
{
  int	temp;

  for (temp = 0; temp < loop_count; temp++); 
}


/******************************************************************************
******************************************************************************/

int main()
{
   int n = 0;
   int s;
   int err;
   struct sockaddr_in addr;
   unsigned int gpio_data = 0;
	unsigned int reg_read, reg_write;
	
   /*
    * Enable and initialize cache
    */
   microblaze_init_icache_range(0, 8192);
   microblaze_enable_icache();

   microblaze_init_dcache_range(0, 8192);
   microblaze_enable_dcache();

   /* Ethernet PHY BCM5221 Setup
	 *		- Issue hard reset to the PHY
	 *		- Set speed to 10 Mbps in both Control and Advertisement registers
	 */
	 
	XEmac_mPhyReset(XPAR_ETHERNET_MAC_BASEADDR);

   /* Readback default values from OPB_ETHERNET MGTCR & MGTDR */
	// reg_read = XEmac_mReadReg(XPAR_ETHERNET_MAC_BASEADDR, XEM_MGTCR_OFFSET);
	// xil_printf("MGTCR = 0x%x\n\r",reg_read);
	// reg_read = XEmac_mReadReg(XPAR_ETHERNET_MAC_BASEADDR, XEM_MGTDR_OFFSET);
	// xil_printf("MGTDR = 0x%x\n\r",reg_read);
	
	/* Use MGTCR & MGTDR to readback default value for BCM5221 Register 0x4 */
	// reg_write = XEM_MGTCR_START_MASK | XEM_MGTCR_RW_NOT_MASK | (0x4 << XEM_MGTCR_REG_ADDR_SHIFT) | XEM_MGTCR_MII_ENABLE_MASK;
	// xil_printf("New MGTCR = 0x%x\n\r",reg_write);
	// XEmac_mWriteReg(XPAR_ETHERNET_MAC_BASEADDR, XEM_MGTCR_OFFSET, reg_write);
	// do
	// 	reg_read = XEmac_mReadReg(XPAR_ETHERNET_MAC_BASEADDR, XEM_MGTCR_OFFSET);
	// while (reg_read & XEM_MGTCR_START_MASK);
	// reg_read = XEmac_mReadReg(XPAR_ETHERNET_MAC_BASEADDR, XEM_MGTDR_OFFSET);
	// xil_printf("PHY Reg 4 = 0x%x\n\r",reg_read);

	/* Use MGTCR & MGTDR to write to BCM5221 Register 0x4 to turn off 100-BASE-X/T advertisement */
	XEmac_mWriteReg(XPAR_ETHERNET_MAC_BASEADDR, XEM_MGTDR_OFFSET, 0x61); // turn off 100 Advertisement
	reg_write = XEM_MGTCR_START_MASK | (0x4 << XEM_MGTCR_REG_ADDR_SHIFT) | XEM_MGTCR_MII_ENABLE_MASK;  //initiate write
	XEmac_mWriteReg(XPAR_ETHERNET_MAC_BASEADDR, XEM_MGTCR_OFFSET, reg_write);
	do // check the start bit until it goes back to 0 to tell when operation is done
		reg_read = XEmac_mReadReg(XPAR_ETHERNET_MAC_BASEADDR, XEM_MGTCR_OFFSET);
	while (reg_read & XEM_MGTCR_START_MASK);

	/* readback of PHY Reg 4 */
	/*
	reg_write = XEM_MGTCR_START_MASK | XEM_MGTCR_RW_NOT_MASK | (0x4 << XEM_MGTCR_REG_ADDR_SHIFT) | XEM_MGTCR_MII_ENABLE_MASK;
	XEmac_mWriteReg(XPAR_ETHERNET_MAC_BASEADDR, XEM_MGTCR_OFFSET, reg_write);
	do
		reg_read = XEmac_mReadReg(XPAR_ETHERNET_MAC_BASEADDR, XEM_MGTCR_OFFSET);
	while (reg_read & XEM_MGTCR_START_MASK);
	reg_read = XEmac_mReadReg(XPAR_ETHERNET_MAC_BASEADDR, XEM_MGTDR_OFFSET);
	xil_printf("PHY Reg 4 = 0x%x\n\r",reg_read);
	*/
	
	/* Use MGTCR & MGTDR to write to BCM5221 Register 0x0 to force 10Mbps operation */
	XEmac_mWriteReg(XPAR_ETHERNET_MAC_BASEADDR, XEM_MGTDR_OFFSET, 0x1000); // turn off 100
	reg_write = XEM_MGTCR_START_MASK | (0x0 << XEM_MGTCR_REG_ADDR_SHIFT) | XEM_MGTCR_MII_ENABLE_MASK;  //writing
	XEmac_mWriteReg(XPAR_ETHERNET_MAC_BASEADDR, XEM_MGTCR_OFFSET, reg_write);
	do
		reg_read = XEmac_mReadReg(XPAR_ETHERNET_MAC_BASEADDR, XEM_MGTCR_OFFSET);
	while (reg_read & XEM_MGTCR_START_MASK);

	/* readback of PHY Reg 0 */
	/*
	reg_write = XEM_MGTCR_START_MASK | XEM_MGTCR_RW_NOT_MASK | (0x0 << XEM_MGTCR_REG_ADDR_SHIFT) | XEM_MGTCR_MII_ENABLE_MASK;
	XEmac_mWriteReg(XPAR_ETHERNET_MAC_BASEADDR, XEM_MGTCR_OFFSET, reg_write);
	do
		reg_read = XEmac_mReadReg(XPAR_ETHERNET_MAC_BASEADDR, XEM_MGTCR_OFFSET);
	while (reg_read & XEM_MGTCR_START_MASK);
	reg_read = XEmac_mReadReg(XPAR_ETHERNET_MAC_BASEADDR, XEM_MGTDR_OFFSET);
	xil_printf("PHY Reg 0 = 0x%x\n\r",reg_read);
	*/

//   xil_printf("\fStarting MicroBlaze Web Server Version 1.2\n\r");
   xil_printf("\n\n\rStarting MicroBlaze Web Server Version 1.2\n\r");
   xil_printf("Built: %s %s\n\n\r", __DATE__, __TIME__);

 

   /*
    * Set up MAC & IP addresses and intialise Ethernet HW Table
    */
   xilnet_eth_init_hw_addr("00:00:00:00:22:38");
   xilnet_eth_init_hw_addr_tbl();
   xilnet_ip_init("192.168.2.105");
//   xilnet_ip_init("1.2.3.4");

   /*
    * Initialize MAC Baseaddress, set MAC address and enable it
    */
   xilnet_mac_init(XPAR_ETHERNET_MAC_BASEADDR);
   XEmac_mSetMacAddress(XPAR_ETHERNET_MAC_BASEADDR, mb_hw_addr);
   XEmac_mEnable(XPAR_ETHERNET_MAC_BASEADDR);

   xil_printf("Browse with Internet Explorer to: http://%d.%d.%d.%d:8080 \n\r", mb_ip_addr[0], mb_ip_addr[1],mb_ip_addr[2],mb_ip_addr[3]);

   /*
    * Initialise the File System and create files
    */
   mfs_init_fs(MFS_NUMBYTES, (char*) MFS_BASE_ADDRESS, MFS_INIT_TYPE);
   create_index();
   
   /*
    * set LEDs to output and DIP switches to input
    */
   XGpio_mSetDataDirection(XPAR_LEDS_4BIT_BASEADDR, 1, 0x0);
   XGpio_mSetDataDirection(XPAR_DIP_SWITCHES_8BIT_BASEADDR, 1, 0xff);
   XGpio_mSetDataDirection(XPAR_LED_7SEGMENT1_BASEADDR, 1, 0x0);
   XGpio_mSetDataDirection(XPAR_LED_7SEGMENT2_BASEADDR, 1, 0x0);

   XGpio_mSetDataReg(XPAR_LED_7SEGMENT2_BASEADDR, 1, 0xff);
 
   /*
    * Create, Bind, Listen on Server Socket
    */
   s = xilsock_socket(AF_INET, SOCK_STREAM, 0);
   if (s == -1) {
      xil_printf("socket() error \n\r");
      exit(1);
   }
   addr.sin_family = AF_INET;
   addr.sin_addr.s_addr = INADDR_ANY;
   addr.sin_port = SERVER_PORT;
   err = xilsock_bind(s, (struct sockaddr *)&addr, sizeof(struct sockaddr));
   if (err == -1) {
      xil_printf("bind() error \n\r");
      exit(1);
   }
   err = xilsock_listen(s, 4);
   if (err == -1) {
      xil_printf("listen() error \n\r");
      exit(1);
   }

   /*
    * Start Accepting Connections on Server Socket
    */
   for (;;) {
      
      int alen = 0; 

      /*
       * Set gpio_data to be displayed on LEDs and 7-Segment.
       */
      count = count % 6;        
      gpio_data = ((unsigned short)led);
      XGpio_mSetDataReg(XPAR_LEDS_4BIT_BASEADDR, 1, gpio_data);
      XGpio_mSetDataReg(XPAR_LED_7SEGMENT1_BASEADDR, 1, display_data[d2]);

      /*
       * Accept new connections
       */
      alen = sizeof(struct sockaddr);
      err = xilsock_accept(s, (struct sockaddr *)&addr, &alen);
      if (xilsock_status_flag & XILSOCK_NEW_CONN) {
         /*
          * Add new web connection
          */
         add_web_conn(err);
      } 
      /*
       * Process all existing connections
       */
      do_proc_conns();


   }
	
   /*
    * Disable cache and reinitialize it so that other
    * applications can be run with no problems
    */
   microblaze_disable_dcache();
   microblaze_init_dcache_range(0, 8192);

   microblaze_disable_icache();
   microblaze_init_icache_range(0, 8192);
	
   return(0);
}


/*
 * Web Connections Management
 */
unsigned char iswebinit = 0;

/*
 * Initialise all web conns
 */
void init_web_conns() {
   int i;

   for (i = 0; i < MAX_WEB_CONNS; i++) {
      web_conns[i].s =-1;
      web_conns[i].file_name = NULL;
      web_conns[i].bytes_rem = 0;
      web_conns[i].state = WEB_CONN_FREE;
   }
   iswebinit = 1;
}


/*
 * Add a web connection
 */
int add_web_conn(int s) {
   int i;

   if (!iswebinit)
      init_web_conns();
   
   for ( i = 0; i < MAX_WEB_CONNS; i++) {
      if (web_conns[i].state == WEB_CONN_FREE)
         break;
   }
   if ( i <= MAX_WEB_CONNS) {
      web_conns[i].s = s;
      web_conns[i].state = WEB_GET;
      return i;
   }
   xil_printf("no free conns \n\r");
   return -1;
}


/*
 * Free a web connection
 */
void free_web_conn(int s) {
   web_conns[s].s = -1;
   web_conns[s].state = WEB_CONN_FREE;
}

/*
 * Process all web connections
 */
void do_proc_conns() {
   int i;
   
   for (i = 0; i < MAX_WEB_CONNS; i++){
      do_proc_req(i);

      // reset buf ptrs of sockets
	  // xilsock_sockets[web_conns[i].s].recvbuf.buf = NULL;
	  // xilsock_sockets[web_conns[i].s].recvbuf.size = 0;

      if (web_conns[i].s != -1) {
      xilsock_sockets[web_conns[i].s].recvbuf.buf = NULL;
      xilsock_sockets[web_conns[i].s].recvbuf.size = 0;
    }

   }
}



/* 
 * Routine that processes requests : 
 * filenames < 10 ; 
 */


#define SND_PTR_SIZE (1500-40)
unsigned char *index1 = "\n<html><head></head><body bgcolor=\"";
unsigned char *bg = "#63B1B1";

//unsigned char *index_html = "\"><center><b><font size=+3>MicroBlaze Web Server on Memec Spartan-3 MB Board</font></b></center><br><font face=\"Garamond\">A Simple Web Server running on <b>MicroBlaze</b>.  Check out the following demos.</font><p><b><font face=\"Garamond\">4-bit LED Display:</font></b><p><font face=\"Garamond\">Type in a hex value and see it displayed as a 4-bit binary value on the LED display on reload.</font><br><form action=\"pl\" method=\"get\"><b><font face=\"Garamond\">Hex Value </font></b><input type=\"text\" size=\"1\" name=\"textbox\"><p><input type=\"submit\" value=\"Submit\"><br></form><font face=\"Garamond\"></font><p><b><font face=\"Garamond\">Changing Colors :</font></b><p><font face=\"Garamond\">See the background color of the page change each time when reloaded.<p><a href=\"index2.html\">Yet Another File on MicroBlaze</a></font><p><b><font face=\"Garamond\">DIP Switches:</font></b><font face=\"Garamond\"></font><p><font face=\"Garamond\">Set Dip Switches 1 2 3 4 and see it displayed as binary on reload</font><b><font face=\"Garamond\"></font></b><p><b><font face=\"Garamond\">DIP Value: ";
//unsigned char *index_html = "\"><center><b><font size=+3>MicroBlaze Web Server on Memec Spartan-3 MB Board</font></b></center><br><font face=\"Garamond\">A Simple Web Server running on <b>MicroBlaze</b>.  Check out the following demos.</font><p><b><font face=\"Garamond\">4-bit LED Display:</font></b><p><font face=\"Garamond\">Type in a hex value and see it displayed as a 4-bit binary value on the LED display on reload.</font><br><form action=\"pl\" method=\"get\"><b><font face=\"Garamond\">Hex Value </font></b><SELECT id=\"select1\" size=\"1\" name=\"select1\"><OPTION selected value=\"0\">0</OPTION><OPTION value=\"1\">1</OPTION><OPTION value=\"2\">2</OPTION><OPTION value=\"3\">3</OPTION><OPTION value=\"4\">4</OPTION><OPTION value=\"5\">5</OPTION><OPTION value=\"6\">6</OPTION><OPTION value=\"7\">7</OPTION><OPTION value=\"8\">8</OPTION><OPTION value=\"9\">9</OPTION><OPTION value=\"A\">A</OPTION><OPTION value=\"B\">B</OPTION><OPTION value=\"C\">C</OPTION><OPTION value=\"D\">D</OPTION><OPTION value=\"E\">E</OPTION><OPTION value=\"F\">F</OPTION></SELECT><BR><p><input type=\"submit\" value=\"Submit\"><br></form><font face=\"Garamond\"></font><p><b><font face=\"Garamond\">Changing Colors :</font></b><p><font face=\"Garamond\">See the background color of the page change each time when reloaded.<p><a href=\"index2.html\">Yet Another File on MicroBlaze</a></font><p><b><font face=\"Garamond\">DIP Switches:</font></b><font face=\"Garamond\"></font><p><font face=\"Garamond\">Set Dip Switches 1 2 3 4 and see it displayed as binary on reload</font><b><font face=\"Garamond\"></font></b><p><b><font face=\"Garamond\">DIP Value: ";
unsigned char *index_html = "\"><center><b><font size=+3>MicroBlaze Web Server on Memec Spartan-3 MB Board</font></b></center><br>"
                            "A Simple Web Server running on <b>MicroBlaze</b>.  Check out the following demos."
							"<p><b>7-Segment Display:</b>"
							"<p>Select a hex value and see it displayed on the 7-segment display after clicking Submit<br>"
							"<form action=\"pl\" method=\"get\"><b>Hex Value </b>"
								"<SELECT id=\"select1\" size=\"1\" name=\"select1\">"
									"<OPTION          value=\"0\">0</OPTION>"
									"<OPTION          value=\"1\">1</OPTION>"
									"<OPTION          value=\"2\">2</OPTION>"
									"<OPTION          value=\"3\">3</OPTION>"
									"<OPTION          value=\"4\">4</OPTION>"
									"<OPTION          value=\"5\">5</OPTION>"
									"<OPTION          value=\"6\">6</OPTION>"
									"<OPTION          value=\"7\">7</OPTION>"
									"<OPTION          value=\"8\">8</OPTION>"
									"<OPTION          value=\"9\">9</OPTION>"
									"<OPTION          value=\"A\">A</OPTION>"
									"<OPTION          value=\"B\">B</OPTION>"
									"<OPTION          value=\"C\">C</OPTION>"
									"<OPTION          value=\"D\">D</OPTION>"
									"<OPTION          value=\"E\">E</OPTION>"
									"<OPTION          value=\"F\">F</OPTION>"
								"</SELECT><BR>"
								"<p><input type=\"submit\" value=\"Submit\"><br>"
							"</form>"
							"<p><b>Changing Colors :</b>"
							"<p>See the background color of the page change each time when reloaded."
							"<p><a href=\"index2.html\">Click here to Control LEDs individually</a>"
							"<p><b>DIP Switches:</b>"
							"<p>Set Dip Switches 1 2 3 4 5 6 7 8 and see it displayed as binary on reload<b></b>"
							"<p><b>DIP Value: ";

unsigned char* index_end = "</b></body></html>";

unsigned char *index2_html = "\"><center><b><font size=+3>MicroBlaze Web Server on Memec Spartan-3 MB Board</font></b></center><br>"
							 "Click the radio buttons to have <b>MicroBlaze</b> light the corresponding LEDs."
							 "<CENTER>"
							 "<form action=\"p2\" method=\"get\">"
								"<TABLE border=1 width=50%>"
								"<TR>"
								"<TD align=center><INPUT id=rb1 type=radio name=rb1></TD>"
								"<TD align=center><INPUT id=rb2 type=radio name=rb2></TD>"
								"<TD align=center><INPUT id=rb3 type=radio name=rb3></TD>"
								"<TD align=center><INPUT id=rb4 type=radio name=rb4></TD>"
								"</TR>"
								"<TR>"
								"<TD align=center>LED1</TD>"
								"<TD align=center>LED2</TD>"
								"<TD align=center>LED3</TD>"
								"<TD align=center>LED4</TD>"
								"</TR>"
								"</TABLE>"
								"<p><input type=\"submit\" value=\"Submit\"><br>"
							"</form>"
							 "</CENTER>"
							 "<p><a href=\"index.html\">Click here to return to the home page</a>"
							 "</body></html>";

/* Constants for GET */
#define G 0x47
#define E 0x45
#define T 0x54

/*
 * Process a Web Connection
 */

void do_proc_req(int n) {
   char    fname[15] = {0};
   int     j, num, fd;
   char *tok;
   volatile unsigned char dip_val = 0;
   unsigned char *sndptr = (unsigned char*)(sendbuf+LINK_HDR_LEN+IP_HDR_LEN*4+(TCP_HDR_LEN*4));
   int i1len, bglen;
   unsigned char * buf = xilsock_sockets[web_conns[n].s].recvbuf.buf;

   if (!buf)
      return;
   
   /*
    * Ack for Data Sent
    */
   if (xilsock_status_flag & XILSOCK_TCP_ACK) {
      xilsock_close(web_conns[n].s);
      free_web_conn(n); 
   }
   /*
    * GET Request
    */
   else if (xilsock_status_flag & XILSOCK_TCP_DATA) {
      /*
       * Read DIP switches and reverse polarity
       */
      dip_val = ~(XGpio_mGetDataReg(XPAR_DIP_SWITCHES_8BIT_BASEADDR, 1));
      dip[0] = ((dip_val & 0x00000080)>>7) + 48;
      dip[1] = ((dip_val & 0x00000040)>>6) + 48;
      dip[2] = ((dip_val & 0x00000020)>>5) + 48;
      dip[3] = ((dip_val & 0x00000010)>>4) + 48;
      dip[4] = ((dip_val & 0x00000008)>>3) + 48;
      dip[5] = ((dip_val & 0x00000004)>>2) + 48;
      dip[6] = ((dip_val & 0x00000002)>>1) + 48;
      dip[7] = (dip_val & 0x00000001) + 48;
      
      i1len = strlen(index1);
      bglen = strlen(bg_tab[count]);

	  // Pull the requested LED setting out of the receive buffer.
      tok = strtok(buf, " ");
      tok = strtok('\0', " ");
      tok = tok+1;
      
      xil_printf("Processing Request...\n\r");

	  // Process Home page submit
      if (tok[0] == 'p' && tok[1] == 'l') {
         d2 = tok[11];
         
         switch(d2) {
         case '0': 
            d2 = led_tab[0];
            break;
         case '1':
            d2 = led_tab[1];
            break;
         case '2':
            d2 = led_tab[2];
            break;
         case '3':
            d2 = led_tab[3];
            break;
         case '4':
            d2 = led_tab[4];
            break;
         case '5':
            d2 = led_tab[5];
            break;
         case '6':
            d2 = led_tab[6];
            break;
         case '7':
            d2 = led_tab[7];
            break;
         case '8':
            d2 = led_tab[8];
            break;
         case '9':
            d2 = led_tab[9];
            break;
         case 'a': case 'A':
            d2 = led_tab[10];
            break;
         case 'b': case 'B':
            d2 = led_tab[11];
            break;
         case 'c': case 'C': 
            d2 = led_tab[12];
            break;
         case 'd': case 'D':
            d2 = led_tab[13];
            break;
         case 'e': case 'E':
            d2 = led_tab[14];
            break;
         case 'f': case 'F':
            d2 = led_tab[15];
            break;
         default:
            d2 = led_tab[0];
            break;
         }  
		 
		 led = d2;    
      }

      else if (tok[0] == 'p' && tok[1] == '2') 
	  {
	  	 // Process LED page submit with radio button info.
		 strcpy(fname, "index2.html");
		 led = 0;

		 while (strlen(tok) >= 3)
		 {
		 	xil_printf("token = %s\n\r", tok);
		 	tok = strstr(tok, "rb") + 2;
			xil_printf("token = %c\n\r", tok[0]);
			
			switch (tok[0])
			{
				case '1':
					led |= 0x8;
					break;
				case '2':
					led |= 0x4;
					break;
				case '3':
					led |= 0x2;
					break;
				case '4':
					led |= 0x1;
					break;
				default:
					xil_printf("Warning - invalid radio button setting from index2.html\n\r");
					break;
			}
			
			tok += 3;			// Skip over "=on" (as in rb1=on)
		 }
			
		 led = ~led & 0xF;		// Reverse the led settings for Active low.
	  }

	  else
	  {
         strcpy(fname,tok);
      }

	  memset(sendbuf, 0, LINK_FRAME_LEN);
      

      // Fill HTTP header and send requested file.
	  // Copy head to send buffer.
      memcpy(sndptr, http_hdr, 17);

	  // If we don't have an html file, use our default name.
      if (!(*fname))
         strcpy(fname, "index.html");

      // Try to open the requested file.  If not available, send the HTTP 404 error.
      if ( (fd = mfs_file_open(fname, MFS_MODE_READ)) < 0) 
	  {
         xil_printf("file not found \n\r");       
         memcpy(sndptr, file_not_found, 24);
         memcpy(&sndptr[24], "File Not Found", strlen("File Not Found"));
         n = xilsock_send(web_conns[n].s, sendbuf, strlen(sndptr));
      }
      
	  // File opened successfully.
	  else 
	  {
         int diplen = 0;

		 // Read the file contents into our send buffer, leaving room for the dynamic
		 // information in our default page.
         j = mfs_file_read(fd, (sndptr+17+i1len+bglen), (1514-14-20-20));

		 // If this is our default page, tack on the dip switch setting at the end.
         if (strcmp(fname, "index.html") == 0) 
		 {
            strcat((sndptr+17+i1len+bglen), dip);
            diplen = 8;
      
	  		// Insert the "selected" HTML text at the proper place in the file to display
			// the dropdown selector for the 7-segment with the correct value.  Space has
			// been left in the SELECT fields to insert the text.
	  		tok = strstr(sndptr + 100, "<OPTION");
			tok = tok + 8 + strlen("<OPTION          value=\"0\">0</OPTION>") * (0xf - d2);
			memcpy(tok, "selected", strlen("selected"));
         }

		 // Copy in the background color value at the appropriate offset in our send buffer.
         memcpy((sndptr+17+i1len), bg_tab[count], bglen);

		 // Copy in the HTML page header.  This completes our HTTP information.
         memcpy((sndptr+17), index1, i1len);

		 // Send the buffer over TCP/IP.
         num = xilsock_send(web_conns[n].s, sendbuf, j+17+i1len+bglen+diplen);
         memset(sendbuf, 0, 1514);
         xil_printf("done..\n\r");
         mfs_file_close(fd);
      }
      count++;      
   } 
}

/*
 * Create Index and Index1 HTML files
 */
void create_index(void) {
   int fd;
   int tmp;
   
   if ( (fd = mfs_file_open("index.html", MFS_MODE_CREATE)) == -1) {
      xil_printf("cant create\n\r");
      exit(-1);
   }
   if ( (fd = mfs_file_open("index.html", MFS_MODE_WRITE)) == -1) { 
      xil_printf("cant open index for write\n\r"); 
      exit(-1); 
   } 
   if ( (tmp = mfs_file_write(fd, index_html, strlen(index_html))) == 0) {
      xil_printf("cant write to file \n\r");
      exit(-1);
   }
   mfs_file_close(fd);



   if ( (fd = mfs_file_open("index2.html", MFS_MODE_CREATE)) == -1) {   
      xil_printf("index2 cant create\n\r");   
      exit(-1);   
   }   
   if ( (fd = mfs_file_open("index2.html", MFS_MODE_WRITE)) == -1) {   
      xil_printf("index2 cant open for write\n\r");   
      exit(-1);   
   }   
   if ( (tmp = mfs_file_write(fd, index2_html, strlen(index2_html))) == 0) {
      xil_printf("cant write index2\n\r");
      exit(-1);
   }
   mfs_file_close(fd);   


}

/*
 * Stack Overflow & Interrupt Handler Dummy Functions
 */
void _stack_overflow_exit(void) {
   xil_printf("Stack Overflow \n\r");
}

void _interrupt_handler() {
}
