#################################################################
# Makefile generated by Xilinx Platform Studio 
# Project:C:\work\tutorials\Memec\Sp3_MB\ISE_EDK_81\Memec_3SMB_MicroBlaze_Base\3SMB_BSB_EDK81\system.xmp
#################################################################

# Name of the Microprocessor system
# The hardware specification of the system is in file :
# C:\work\tutorials\Memec\Sp3_MB\ISE_EDK_81\Memec_3SMB_MicroBlaze_Base\3SMB_BSB_EDK81\system.mhs
# The software specification of the system is in file :
# C:\work\tutorials\Memec\Sp3_MB\ISE_EDK_81\Memec_3SMB_MicroBlaze_Base\3SMB_BSB_EDK81\system.mss

include system_incl.make


#################################################################
# EXTERNAL TARGETS
#################################################################
all:
	@echo "Makefile to build a Microprocessor system :"
	@echo "Run make with any of the following targets"
	@echo " "
	@echo "  netlist  : Generates the netlist for the given MHS "
	@echo "  bits     : Runs Implementation tools to generate the bitstream"
	@echo "  exporttopn:Export to ProjNav"
	@echo " "
	@echo "  libs     : Configures the sw libraries for this system"
	@echo "  program  : Compiles the program sources for all the processor instances"
	@echo " "
	@echo "  init_bram: Initializes bitstream with BRAM data"
	@echo "  ace      : Generate ace file from bitstream and elf"
	@echo "  download : Downloads the bitstream onto the board"
	@echo " "
	@echo "  sim      : Generates HDL simulation models and runs simulator for chosen simulation mode"
	@echo "  simmodel : Generates HDL simulation models for chosen simulation mode"
	@echo "  behavioral:Generates behavioral HDL models with BRAM initialization"
	@echo "  structural:Generates structural simulation HDL models with BRAM initialization"
	@echo "  timing   : Generates timing simulation HDL models with BRAM initialization"
	@echo "  vp       : Generates virtual platform model"
	@echo " "
	@echo "  netlistclean: Deletes netlist"
	@echo "  bitsclean: Deletes bit, ncd, bmm files"
	@echo "  hwclean  : Deletes implementation dir"
	@echo "  libsclean: Deletes sw libraries"
	@echo "  programclean: Deletes compiled ELF files"
	@echo "  swclean  : Deletes sw libraries and ELF files"
	@echo "  simclean : Deletes simulation dir"
	@echo "  vpclean  : Deletes virtualplatform dir"
	@echo "  clean    : Deletes all generated files/directories"
	@echo " "
	@echo "  make <target> : (Default)"
	@echo "      Creates a Microprocessor system using default initializations"
	@echo "      specified for each processor in MSS file"


bits: $(SYSTEM_BIT)

ace: $(SYSTEM_ACE)

netlist: $(POSTSYN_NETLIST)

libs: $(LIBRARIES)

program: $(ALL_USER_ELF_FILES)

download: $(DOWNLOAD_BIT) dummy
	@echo "*********************************************"
	@echo "Downloading Bitstream onto the target board"
	@echo "*********************************************"
	impact -batch etc/download.cmd

init_bram: $(DOWNLOAD_BIT)

sim: $(DEFAULT_SIM_SCRIPT)
	cd simulation/behavioral; \
	$(SIM_CMD)  &

simmodel: $(DEFAULT_SIM_SCRIPT)

behavioral_model: $(BEHAVIORAL_SIM_SCRIPT)

structural_model: $(STRUCTURAL_SIM_SCRIPT)

vp: $(VPEXEC)

clean: hwclean libsclean programclean simclean vpclean
	rm -f _impact.cmd

hwclean: netlistclean bitsclean
	rm -rf implementation synthesis xst hdl
	rm -rf xst.srp $(SYSTEM).srp

netlistclean:
	rm -f $(POSTSYN_NETLIST)
	rm -f $(BMM_FILE)

bitsclean:
	rm -f $(SYSTEM_BIT)
	rm -f implementation/$(SYSTEM).ncd
	rm -f implementation/$(SYSTEM)_bd.bmm 

bitsclean:

simclean: 
	rm -rf simulation/behavioral

swclean: libsclean programclean
	@echo ""

libsclean: $(LIBSCLEAN_TARGETS)

programclean: $(PROGRAMCLEAN_TARGETS)

vpclean:
	rm -rf virtualplatform

#################################################################
# SOFTWARE PLATFORM FLOW
#################################################################


$(LIBRARIES): $(MHSFILE) $(MSSFILE) __xps/libgen.opt
	@echo "*********************************************"
	@echo "Creating software libraries..."
	@echo "*********************************************"
	libgen $(LIBGEN_OPTIONS) $(MSSFILE)


microblaze_0_libsclean:
	rm -rf microblaze_0/lib/

$(MICROBLAZE_0_XMDSTUB): $(LIBRARIES)

#################################################################
# SOFTWARE APPLICATION TESTAPP_MEMORY
#################################################################

TestApp_Memory_program: $(TESTAPP_MEMORY_OUTPUT) 

$(TESTAPP_MEMORY_OUTPUT) : $(TESTAPP_MEMORY_SOURCES) $(TESTAPP_MEMORY_HEADERS) $(TESTAPP_MEMORY_LINKER_SCRIPT) \
                    $(LIBRARIES) __xps/testapp_memory_compiler.opt
	@mkdir -p $(TESTAPP_MEMORY_OUTPUT_DIR) 
	$(TESTAPP_MEMORY_CC) $(TESTAPP_MEMORY_CC_OPT) $(TESTAPP_MEMORY_SOURCES) -o $(TESTAPP_MEMORY_OUTPUT) \
	$(TESTAPP_MEMORY_OTHER_CC_FLAGS) $(TESTAPP_MEMORY_INCLUDES) $(TESTAPP_MEMORY_LIBPATH) \
	$(TESTAPP_MEMORY_CFLAGS) $(TESTAPP_MEMORY_LFLAGS) 
	$(TESTAPP_MEMORY_CC_SIZE) $(TESTAPP_MEMORY_OUTPUT) 

TestApp_Memory_programclean:
	rm -f $(TESTAPP_MEMORY_OUTPUT) 

#################################################################
# SOFTWARE APPLICATION TESTAPP_PERIPHERAL
#################################################################

TestApp_Peripheral_program: $(TESTAPP_PERIPHERAL_OUTPUT) 

$(TESTAPP_PERIPHERAL_OUTPUT) : $(TESTAPP_PERIPHERAL_SOURCES) $(TESTAPP_PERIPHERAL_HEADERS) $(TESTAPP_PERIPHERAL_LINKER_SCRIPT) \
                    $(LIBRARIES) __xps/testapp_peripheral_compiler.opt
	@mkdir -p $(TESTAPP_PERIPHERAL_OUTPUT_DIR) 
	$(TESTAPP_PERIPHERAL_CC) $(TESTAPP_PERIPHERAL_CC_OPT) $(TESTAPP_PERIPHERAL_SOURCES) -o $(TESTAPP_PERIPHERAL_OUTPUT) \
	$(TESTAPP_PERIPHERAL_OTHER_CC_FLAGS) $(TESTAPP_PERIPHERAL_INCLUDES) $(TESTAPP_PERIPHERAL_LIBPATH) \
	$(TESTAPP_PERIPHERAL_CFLAGS) $(TESTAPP_PERIPHERAL_LFLAGS) 
	$(TESTAPP_PERIPHERAL_CC_SIZE) $(TESTAPP_PERIPHERAL_OUTPUT) 

TestApp_Peripheral_programclean:
	rm -f $(TESTAPP_PERIPHERAL_OUTPUT) 

#################################################################
# SOFTWARE APPLICATION RUN_FROM_DDR_NOLINK
#################################################################

Run_From_DDR_NoLink_program: $(RUN_FROM_DDR_NOLINK_OUTPUT) 

$(RUN_FROM_DDR_NOLINK_OUTPUT) : $(RUN_FROM_DDR_NOLINK_SOURCES) $(RUN_FROM_DDR_NOLINK_HEADERS) $(RUN_FROM_DDR_NOLINK_LINKER_SCRIPT) \
                    $(LIBRARIES) __xps/run_from_ddr_nolink_compiler.opt
	@mkdir -p $(RUN_FROM_DDR_NOLINK_OUTPUT_DIR) 
	$(RUN_FROM_DDR_NOLINK_CC) $(RUN_FROM_DDR_NOLINK_CC_OPT) $(RUN_FROM_DDR_NOLINK_SOURCES) -o $(RUN_FROM_DDR_NOLINK_OUTPUT) \
	$(RUN_FROM_DDR_NOLINK_OTHER_CC_FLAGS) $(RUN_FROM_DDR_NOLINK_INCLUDES) $(RUN_FROM_DDR_NOLINK_LIBPATH) \
	$(RUN_FROM_DDR_NOLINK_CFLAGS) $(RUN_FROM_DDR_NOLINK_LFLAGS) 
	$(RUN_FROM_DDR_NOLINK_CC_SIZE) $(RUN_FROM_DDR_NOLINK_OUTPUT) 

Run_From_DDR_NoLink_programclean:
	rm -f $(RUN_FROM_DDR_NOLINK_OUTPUT) 

#################################################################
# SOFTWARE APPLICATION RUN_FROM_DDR_LINK
#################################################################

Run_From_DDR_Link_program: $(RUN_FROM_DDR_LINK_OUTPUT) 

$(RUN_FROM_DDR_LINK_OUTPUT) : $(RUN_FROM_DDR_LINK_SOURCES) $(RUN_FROM_DDR_LINK_HEADERS) $(RUN_FROM_DDR_LINK_LINKER_SCRIPT) \
                    $(LIBRARIES) __xps/run_from_ddr_link_compiler.opt
	@mkdir -p $(RUN_FROM_DDR_LINK_OUTPUT_DIR) 
	$(RUN_FROM_DDR_LINK_CC) $(RUN_FROM_DDR_LINK_CC_OPT) $(RUN_FROM_DDR_LINK_SOURCES) -o $(RUN_FROM_DDR_LINK_OUTPUT) \
	$(RUN_FROM_DDR_LINK_OTHER_CC_FLAGS) $(RUN_FROM_DDR_LINK_INCLUDES) $(RUN_FROM_DDR_LINK_LIBPATH) \
	$(RUN_FROM_DDR_LINK_CFLAGS) $(RUN_FROM_DDR_LINK_LFLAGS) 
	$(RUN_FROM_DDR_LINK_CC_SIZE) $(RUN_FROM_DDR_LINK_OUTPUT) 

Run_From_DDR_Link_programclean:
	rm -f $(RUN_FROM_DDR_LINK_OUTPUT) 

#################################################################
# SOFTWARE APPLICATION FLASH_TEST
#################################################################

Flash_Test_program: $(FLASH_TEST_OUTPUT) 

$(FLASH_TEST_OUTPUT) : $(FLASH_TEST_SOURCES) $(FLASH_TEST_HEADERS) $(FLASH_TEST_LINKER_SCRIPT) \
                    $(LIBRARIES) __xps/flash_test_compiler.opt
	@mkdir -p $(FLASH_TEST_OUTPUT_DIR) 
	$(FLASH_TEST_CC) $(FLASH_TEST_CC_OPT) $(FLASH_TEST_SOURCES) -o $(FLASH_TEST_OUTPUT) \
	$(FLASH_TEST_OTHER_CC_FLAGS) $(FLASH_TEST_INCLUDES) $(FLASH_TEST_LIBPATH) \
	$(FLASH_TEST_CFLAGS) $(FLASH_TEST_LFLAGS) 
	$(FLASH_TEST_CC_SIZE) $(FLASH_TEST_OUTPUT) 

Flash_Test_programclean:
	rm -f $(FLASH_TEST_OUTPUT) 

#################################################################
# SOFTWARE APPLICATION WEBSERVER
#################################################################

WebServer_program: $(WEBSERVER_OUTPUT) 

$(WEBSERVER_OUTPUT) : $(WEBSERVER_SOURCES) $(WEBSERVER_HEADERS) $(WEBSERVER_LINKER_SCRIPT) \
                    $(LIBRARIES) __xps/webserver_compiler.opt
	@mkdir -p $(WEBSERVER_OUTPUT_DIR) 
	$(WEBSERVER_CC) $(WEBSERVER_CC_OPT) $(WEBSERVER_SOURCES) -o $(WEBSERVER_OUTPUT) \
	$(WEBSERVER_OTHER_CC_FLAGS) $(WEBSERVER_INCLUDES) $(WEBSERVER_LIBPATH) \
	$(WEBSERVER_CFLAGS) $(WEBSERVER_LFLAGS) 
	$(WEBSERVER_CC_SIZE) $(WEBSERVER_OUTPUT) 

WebServer_programclean:
	rm -f $(WEBSERVER_OUTPUT) 

#################################################################
# BOOTLOOP ELF FILES
#################################################################



$(MICROBLAZE_0_BOOTLOOP): $(MICROBLAZE_BOOTLOOP)
	@mkdir -p $(BOOTLOOP_DIR)
	cp -f $(MICROBLAZE_BOOTLOOP) $(MICROBLAZE_0_BOOTLOOP)

#################################################################
# HARDWARE IMPLEMENTATION FLOW
#################################################################


$(BMM_FILE) \
$(WRAPPER_NGC_FILES): $(MHSFILE) __xps/platgen.opt \
                      $(CORE_STATE_DEVELOPMENT_FILES)
	@echo "****************************************************"
	@echo "Creating system netlist for hardware specification.."
	@echo "****************************************************"
	platgen $(PLATGEN_OPTIONS) -st xst $(MHSFILE)

$(POSTSYN_NETLIST): $(WRAPPER_NGC_FILES)
	@echo "Running synthesis..."
	bash -c "cd synthesis; ./synthesis.sh"

$(SYSTEM_BIT): $(FPGA_IMP_DEPENDENCY)
	@echo "*********************************************"
	@echo "Running Xilinx Implementation tools.."
	@echo "*********************************************"
	@cp -f $(UCF_FILE) implementation/$(SYSTEM).ucf
	@cp -f $(XFLOW_OPT_FILE) implementation/xflow.opt
	xflow -wd implementation -p $(DEVICE) -implement xflow.opt $(SYSTEM).ngc
	@echo "*********************************************"
	@echo "Running Bitgen.."
	@echo "*********************************************"
	@cp -f $(BITGEN_UT_FILE) implementation/bitgen.ut
	cd implementation; bitgen -w -f bitgen.ut $(SYSTEM)

exporttopn: 
	@echo "You have chosen XPS for implementation tool flow."
	@echo "Please select ProjNav as your implementation flow in Project Options."
	@echo "In batch mode, use commad xset pnproj <nplfile>."

$(DOWNLOAD_BIT): $(SYSTEM_BIT) $(BRAMINIT_ELF_FILES) __xps/bitinit.opt
	@cp -f implementation/$(SYSTEM)_bd.bmm .
	@echo "*********************************************"
	@echo "Initializing BRAM contents of the bitstream"
	@echo "*********************************************"
	bitinit $(MHSFILE) $(SEARCHPATHOPT) $(BRAMINIT_ELF_FILE_ARGS) \
	-bt $(SYSTEM_BIT) -o $(DOWNLOAD_BIT)
	@rm -f $(SYSTEM)_bd.bmm

$(SYSTEM_ACE): $(DOWNLOAD_BIT) $(TESTAPP_MEMORY_OUTPUT) $(TESTAPP_PERIPHERAL_OUTPUT) $(RUN_FROM_DDR_NOLINK_OUTPUT) $(RUN_FROM_DDR_LINK_OUTPUT) $(FLASH_TEST_OUTPUT) $(WEBSERVER_OUTPUT) 
	@echo "*********************************************"
	@echo "Creating system ace file"
	@echo "*********************************************"
	xmd -tcl genace.tcl -jprog -hw $(DOWNLOAD_BIT) -elf $(TESTAPP_MEMORY_OUTPUT) $(TESTAPP_PERIPHERAL_OUTPUT) $(RUN_FROM_DDR_NOLINK_OUTPUT) $(RUN_FROM_DDR_LINK_OUTPUT) $(FLASH_TEST_OUTPUT) $(WEBSERVER_OUTPUT)  -target mdm  -ace $(SYSTEM_ACE)

#################################################################
# SIMULATION FLOW
#################################################################


################## BEHAVIORAL SIMULATION ##################

$(BEHAVIORAL_SIM_SCRIPT): $(MHSFILE) __xps/simgen.opt \
                          $(BRAMINIT_ELF_FILES)
	@echo "*********************************************"
	@echo "Creating behavioral simulation models..."
	@echo "*********************************************"
	simgen $(SIMGEN_OPTIONS) -m behavioral $(MHSFILE)

################## STRUCTURAL SIMULATION ##################

$(STRUCTURAL_SIM_SCRIPT): $(WRAPPER_NGC_FILES) __xps/simgen.opt \
                          $(BRAMINIT_ELF_FILES)
	@echo "*********************************************"
	@echo "Creating structural simulation models..."
	@echo "*********************************************"
	simgen $(SIMGEN_OPTIONS) -sd implementation -m structural $(MHSFILE)


################## TIMING SIMULATION ##################

$(TIMING_SIM_SCRIPT): $(SYSTEM_BIT) __xps/simgen.opt \
                      $(BRAMINIT_ELF_FILES)
	@echo "*********************************************"
	@echo "Creating timing simulation models..."
	@echo "*********************************************"
	simgen $(SIMGEN_OPTIONS) -sd implementation -m timing $(MHSFILE)

#################################################################
# VIRTUAL PLATFORM FLOW
#################################################################


$(VPEXEC): $(MHSFILE) __xps/vpgen.opt
	@echo "****************************************************"
	@echo "Creating virtual platform for hardware specification.."
	@echo "****************************************************"
	vpgen $(VPGEN_OPTIONS) $(MHSFILE)

dummy:
	@echo ""

