/******************************************************************************
* Function name         :  system.c
* returns               :  
* Created by            :  JBE 
* Date Created          :  
* Company				:  Memec
* Description           :  Main Program
* Notes                 :  This program does things 
******************************************************************************/
#include "xparameters.h"
#include "xuartlite_l.h"
#include "xgpio_l.h"
#include "stdio.h"
#include "lcd.h"

int main(void)
{
	int i;
	int	gpio_data;
	char temp;
	char cc[16];	// array to hold the command MAXIMUM length = 18 characters (18 + position 0 unused + enter = 20)
	XGpio_mSetDataDirection(XPAR_LEDS_BASEADDR, 1,0x00);

	lcd_init(XPAR_LCD_BASEADDR);

	XGpio_mSetDataReg(XPAR_LEDS_BASEADDR, 1,0xFF);

// Print a banner to the UART
	print("         ####################################################\n\r");
	print("         #                                                  #\n\r");
	print("         #                        Memec                     #\n\r");
	print("         #          Spartan-3 MB Development Board          #\n\r");
	print("         #                 MicroBlaze LCD DEMO              #\n\r");
	print("         #                                                  #\n\r");
	print("         ####################################################\n\r");
	print("\n\r");
	print("\n\r");

	while ( 1 ) 
	{
	lcd_clear(XPAR_LCD_BASEADDR);
	_wait(50000);
	lcd_line(XPAR_LCD_BASEADDR, 1);
	lcd_write(XPAR_LCD_BASEADDR, " >>> MEMEC <<<");
	lcd_line(XPAR_LCD_BASEADDR, 2);
	lcd_write(XPAR_LCD_BASEADDR, "  Spartan-3 MB");
    
	_wait(5000000);
	XGpio_mSetDataReg(XPAR_LEDS_BASEADDR, 1,0x0E);
	_wait(5000000);
	XGpio_mSetDataReg(XPAR_LEDS_BASEADDR, 1,0x0D);
	_wait(5000000);
	XGpio_mSetDataReg(XPAR_LEDS_BASEADDR, 1,0x0B);
	_wait(5000000);
	XGpio_mSetDataReg(XPAR_LEDS_BASEADDR, 1,0x07);
	_wait(5000000);
	XGpio_mSetDataReg(XPAR_LEDS_BASEADDR, 1,0x0B);
	_wait(5000000);
	XGpio_mSetDataReg(XPAR_LEDS_BASEADDR, 1,0x0D);
	_wait(5000000);
	XGpio_mSetDataReg(XPAR_LEDS_BASEADDR, 1,0x0E);
	_wait(5000000);
	XGpio_mSetDataReg(XPAR_LEDS_BASEADDR, 1,0x0F);
	_wait(5000000);
	XGpio_mSetDataReg(XPAR_LEDS_BASEADDR, 1,0x00);
	_wait(16000000);

	lcd_clear(XPAR_LCD_BASEADDR);
	_wait(50000);
	lcd_line(XPAR_LCD_BASEADDR, 1);
	lcd_write(XPAR_LCD_BASEADDR, " *** XILINX *** ");
	lcd_line(XPAR_LCD_BASEADDR, 2);
	lcd_write(XPAR_LCD_BASEADDR, " Delivers 90nm!");

	for (i = 0; i < 4; i++)
	{
	_wait(3000000);
	XGpio_mSetDataReg(XPAR_LEDS_BASEADDR, 1,0x0A);
	_wait(3000000);
	XGpio_mSetDataReg(XPAR_LEDS_BASEADDR, 1,0x05);
	_wait(3000000);
	XGpio_mSetDataReg(XPAR_LEDS_BASEADDR, 1,0x0A);
	}
	_wait(5000000);
	XGpio_mSetDataReg(XPAR_LEDS_BASEADDR, 1,0x00);


	lcd_clear(XPAR_LCD_BASEADDR);
	_wait(50000);
	lcd_line(XPAR_LCD_BASEADDR, 1);
	lcd_write(XPAR_LCD_BASEADDR, "Memec & Xilinx =");
	lcd_line(XPAR_LCD_BASEADDR, 2);
	lcd_write(XPAR_LCD_BASEADDR, " A Winning Team!");

	for (i = 0; i < 8; i++)
	{
	 gpio_data = 0x00000008;

	 while (gpio_data != 0x00000001)
	 {
		XGpio_mSetDataReg(XPAR_LEDS_BASEADDR, 1, ~(gpio_data));
		gpio_data = gpio_data >> 1; 
		_wait(1000000);
	 }

	 while (gpio_data != 0x00000008)
	 {
		XGpio_mSetDataReg(XPAR_LEDS_BASEADDR, 1, ~(gpio_data));
		gpio_data = gpio_data << 1; 
		_wait(3000000);
	 }
	}

	}
}