# Memec Spartan-3 3S1500 MB Rev 2 Demo Board
# iMPACT Batch command file for command line configuration
# 
# To launch, type the following from a command line:
#	impact -batch <filename.cmd>
#
# For more details, you can find the Impact batch file commands
# in an appendix of the Impact User's Guide:
#	http://www.support.xilinx.com/support/sw_manuals/xilinx6/download/pac.zip


# Set iMPACT into Boundary-scan programming mode
setMode -bscan


# Let iMPACT automatically search and find your programming cable
setCable -port auto


# Add devices to the programming chain.  This can be done using
# one of two methods (method #2 used in this case):

# 1) Load a previously generated CDF, which defines the JTAG chain
# loadCdf -file 3SMB_demo.cdf
#
# 2) Create the JTAG chain manually
# Device #1 is an XCF04S PROM bypassed using a BSDL file
addDevice -p 1 -file etc/xcf04s_vo20.bsd

# Device #2 is an XCF01S PROM bypassed using a BSDL file
addDevice -p 2 -file etc/xcf01s_vo20.bsd

# Device #3 is the Spartan-3 with a bit file
addDevice -p 3 -file implementation/download.bit


#Program the device at Position #3, which is the Spartan-3
program -p 3


#Quit iMPACT
quit

